/* Problem URL: https://codeforces.com/contest/2154/problem/C2 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


const int maxn = 2e5 + 2;
int divs[maxn];

void pre()
{
    fill(divs, divs + maxn, 1);

    nrep(i, 2, maxn) {
        if (divs[i] != 1) {
            continue;
        }

        for (int j = i; j < maxn; j += i) {
            divs[j] = i;
        }
    }
}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    V<pair<ll, int>> a(n);

    repv(i, a) {
        cin >> i.second;
    }

    repv(i, a) {
        cin >> i.first;
    }

    set<int> primes;

    auto getprimes = [&](int now) {
        while (divs[now] != 1) {
            if (primes.count(divs[now])) {
                return true;
            }
            primes.insert(divs[now]);
            int prev = divs[now];
            while (divs[now] == prev) {
                now /= divs[now];
            }
        }

        return false;
    };

    auto findprimes = [&](int now) {
        while (divs[now] != 1) {
            if (primes.count(divs[now])) {
                return true;
            }
            int prev = divs[now];
            while (divs[now] == prev) {
                now /= divs[now];
            }
        }

        return false;
    };

    rep(i, n) {
        if (getprimes(a[i].second)) {
            cout << "0\n";
            return;
        }
    }

    sortv(a);

    ll ans = a[0].first + a[1].first;
    rep(i, n) {
        if (findprimes(a[i].second + 1)) {
            rmin(ans, a[i].first);
        }
    }

    if (primes.empty()) {
        cout << ans << '\n';
        return;
    }


    repv(i, primes) {
        if (a[0].second % i == 0) {
            continue;
        }

        rmin(ans, (i - a[0].second % i) * a[0].first);
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
